package com.giderosmobile.android.plugins.ads.frameworks;

import java.lang.ref.WeakReference;
import android.app.Activity;
import android.util.SparseArray;
import android.view.KeyEvent;

import com.giderosmobile.android.plugins.ads.*;
import com.unity3d.ads.*;


public class AdsUnity implements AdsInterface, IUnityAdsListener {

	private WeakReference<Activity> sActivity;
	private AdsManager mngr;
	private static AdsUnity me;// get the VunglePub instance

	public void onCreate(WeakReference<Activity> activity)
	{
		me = this;
		sActivity = activity;
		mngr = new AdsManager();
	}

	//on destroy event
	public void onDestroy(){}

	public void onStart(){}

	public void onStop(){}

	public void onPause()
	{
	}

	public void onResume()
	{
	}

	public boolean onKeyUp(int keyCode, KeyEvent event) {
		return false;
	}

	public void setKey(final Object parameters){
		SparseArray<String> param = (SparseArray<String>)parameters;
		UnityAds.initialize(sActivity.get(), param.get(0), this);
	}


	//load an Ad
	public void loadAd(final Object parameters)
	{
		final SparseArray<String> param = (SparseArray<String>)parameters;
		final String type = param.get(0);
			mngr.set(UnityAds.class, type, new AdsStateChangeListener(){
				@Override
				public void onShow() {
					UnityAds.show(sActivity.get(),type);
				}
				@Override
				public void onDestroy() {}
				@Override
				public void onHide() {}
			});
			mngr.load(type);
	}

	public void showAd(final Object parameters)
	{
		SparseArray<String> param = (SparseArray<String>)parameters;
		String type = param.get(0);
		if(mngr.get(type) == null)
		{
			loadAd(parameters);
		}
		mngr.show(type);
	}

	//remove ad
	public void hideAd(String type)
	{
		mngr.hide(type);
	}

	public int getWidth(){
		return 0;
	}

	public int getHeight(){
		return 0;
	}

	@Override
	public void enableTesting() {

	}

	@Override
	public void onUnityAdsReady(String s) {
		Ads.adReceived(this,s);
	}

	@Override
	public void onUnityAdsStart(String s) {
		Ads.adDisplayed(this,s);
	}

	@Override
	public void onUnityAdsFinish(String s, UnityAds.FinishState finishState) {
		if (finishState== UnityAds.FinishState.COMPLETED)
			Ads.adActionEnd(this,s);
		else if (finishState== UnityAds.FinishState.SKIPPED)
			Ads.adDismissed(this,s);
		else if (finishState== UnityAds.FinishState.ERROR)
			Ads.adFailed(this,s,"");
	}

	@Override
	public void onUnityAdsError(UnityAds.UnityAdsError unityAdsError, String s) {
	}
}
